<template>
  <div class="d-flex align-items-baseline">
    <span>{{ displayPrefix }}</span>
    <div class="d-flex flex-column ml-1">
      <span>{{ displayCoordinatesSexagesimal }}</span>
      <span><small>{{ displayCoordinatesDecimal }}</small></span>
    </div>
    <button-copy
      v-if="displayCopyButton"
      :value="displayCoordinates"
    />
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { base as astronomia, sexagesimal } from 'astronomia';
import ButtonCopy from '@/components/ButtonCopy.vue';

export default Vue.extend({
  components: {
    ButtonCopy,
  },

  props: {
    dec: {
      required: true,
      type: Number,
    },
    ra: {
      required: true,
      type: Number,
    },
    fractionDigits: {
      required: false,
      default: 2,
      type: Number,
    },
    displayPrefix: {
      required: false,
      default: 'ICRS: ',
      type: String,
    },
    displayCopyButton: {
      required: false,
      default: true,
      type: Boolean,
    },
  },

  computed: {
    displayCoordinatesSexagesimal(): string {
      return `${this.degreesToHMS(this.ra)} ${this.degreesToDMS(this.dec)}`;
    },
    displayCoordinatesDecimal(): string {
      return `${this.ra.toFixed(4)} ${this.dec.toFixed(4)}`;
    },
  },

  methods: {
    degreesToDMS(degrees: number): string {
      const [neg, d, m, s] = new sexagesimal.Angle(astronomia.toRad(degrees)).toDMS();
      return `${neg ? '-' : ''}${d.toString().padStart(2, '0')}:${m
        .toString()
        .padStart(2, '0')}:${s.toFixed(this.fractionDigits)}`;
    },

    degreesToHMS(degrees: number): string {
      const [neg, h, m, s] = new sexagesimal.HourAngle(astronomia.toRad(degrees)).toDMS();
      return `${neg ? '-' : ''}${h.toString().padStart(2, '0')}:${m
        .toString()
        .padStart(2, '0')}:${s.toFixed(this.fractionDigits)}`;
    },
  },
});
</script>

<style lang="scss" scoped>
.b-dropdown button {
  padding: 0;
}
</style>
